dnl popen - Additional macros for `autoconf'

dnl -- Pinched from FPTOOLS/GHC
dnl
dnl POPEN_GHC_VERSION(version)
dnl POPEN_GHC_VERSION(major, minor [, patchlevel])
dnl POPEN_GHC_VERSION(version, major, minor, patchlevel)
dnl
dnl Test for version of installed ghc.  Uses $GHC.
dnl [original version pinched from c2hs]
dnl
AC_DEFUN(POPEN_GHC_VERSION,
[define([POPEN_CV_GHC_VERSION], [popen_cv_ghc_version])dnl
AC_CACHE_CHECK([version of ghc], POPEN_CV_GHC_VERSION, [dnl
${GHC-ghc} --version > conftestghc 2>&1
  cat conftestghc >&AC_FD_CC
dnl `Useless Use Of cat' award...
changequote(<<, >>)dnl
  POPEN_CV_GHC_VERSION=`cat conftestghc | sed -n -e 's/, patchlevel *\([0-9]\)/.\1/;s/.* version \([0-9.]\+\).*/\1/p'`
changequote([, ])dnl
  rm -fr conftest*
  if test "[$]POPEN_CV_GHC_VERSION" = ""
  then
    POPEN_CV_GHC_VERSION='unknown'
  fi])
changequote(<<, >>)dnl
POPEN_CV_GHC_VERSION<<_major>>=`echo <<$>>POPEN_CV_GHC_VERSION | sed -e 's/^\([0-9]\).*/\1/'`
POPEN_CV_GHC_VERSION<<_minor>>=`echo <<$>>POPEN_CV_GHC_VERSION | sed -e 's/^[0-9]\.\([0-9]*\).*/\1/'`
POPEN_CV_GHC_VERSION<<_pl>>=`echo <<$>>POPEN_CV_GHC_VERSION | sed -n -e 's/^[0-9]\.[0-9]*\.\([0-9]*\)/\1/p'`
changequote([, ])dnl
if test "[$]POPEN_CV_GHC_VERSION[_pl]" = ""
then
  POPEN_CV_GHC_VERSION[_all]="[$]POPEN_CV_GHC_VERSION[_major].[$]POPEN_CV_GHC_VERSION[_minor]"
  POPEN_CV_GHC_VERSION[_pl]="0"
else
  POPEN_CV_GHC_VERSION[_all]="[$]POPEN_CV_GHC_VERSION[_major].[$]POPEN_CV_GHC_VERSION[_minor].[$]POPEN_CV_GHC_VERSION[_pl]"
fi
ifelse($#, [1], [dnl
[$1]="[$]POPEN_CV_GHC_VERSION[_all]"
], $#, [2], [dnl
[$1]="[$]POPEN_CV_GHC_VERSION[_major]"
[$2]="[$]POPEN_CV_GHC_VERSION[_minor]"
], $#, [3], [dnl
[$1]="[$]POPEN_CV_GHC_VERSION[_major]"
[$2]="[$]POPEN_CV_GHC_VERSION[_minor]"
[$3]="[$]POPEN_CV_GHC_VERSION[_pl]"
], $#, [4], [dnl
[$1]="[$]POPEN_CV_GHC_VERSION[_all]"
[$2]="[$]POPEN_CV_GHC_VERSION[_major]"
[$3]="[$]POPEN_CV_GHC_VERSION[_minor]"
[$4]="[$]POPEN_CV_GHC_VERSION[_pl]"
], [AC_MSG_ERROR([wrong number of arguments to [$0]])])dnl
undefine([POPEN_CV_GHC_VERSION])dnl
])dnl

dnl -- Pinched from Michael Weber's HaskellMPI
dnl
dnl POPEN_PROG_CHECK_VERSION(VERSIONSTR1, TEST, VERSIONSTR2,
dnl                          ACTION-IF-TRUE [, ACTION-IF-FALSE])
dnl
dnl compare versions field-wise (separator is '.')
dnl TEST is one of {-lt,-le,-eq,-ge,-gt}
dnl
dnl quite shell-independent and SUSv2 compliant code
dnl
dnl NOTE: the loop could be unrolled within autoconf, but the
dnl       macro code would be a) longer and b) harder to debug... ;)
dnl
AC_DEFUN(POPEN_PROG_CHECK_VERSION,
[if ( IFS=".";
      a="[$1]";  b="[$3]";
      while test -n "$a$b"
      do
              set -- [$]a;  h1="[$]1";  shift 2>/dev/null;  a="[$]*"
              set -- [$]b;  h2="[$]1";  shift 2>/dev/null;  b="[$]*"
              test -n "[$]h1" || h1=0;  test -n "[$]h2" || h2=0
              test [$]{h1} -eq [$]{h2} || break
      done
      test [$]{h1} [$2] [$]{h2}
    )
then ifelse([$4],,[:],[
  $4])
ifelse([$5],,,
[else
  $5])
fi])])dnl
